/******************************************************************************************
 * To add additional script to the scripting widget, create/upload a JavaScript file
 * to the 'scripts' folder. Open the scripting.html file in the editor by double clicking
 * the file in the Project view. Append the filename to the 'scripts' attribute in the
 * ti-widget-scripting element, separated each script filename by a comma.
 ******************************************************************************************/

const SCRIPT_START_MESSAGE = 'Script Started';
const SCRIPT_END_MESSAGE   = 'Script Ended';

/**
 * The entry point for the script, this function will be called when the user presses
 * the RUN button in the scripting widget. Any call to access the controller must be
 * initiated within this function.
 */
function main() {
    /*
     * To debug this script, open the debugger in the main application window that
     * spawned this window. For most browser, press F12 to enable debugging.
     *
     * The 'debugger' keyword is an inline breakpoint. Uncomment the following line to stop
     * the script at main when the debugger is opened.
     */
     //debugger

    /* Log to text file */
     //log(SCRIPT_START_MESSAGE);
     
    // read('id_reg');

    /* Read the acc_en register and toggle it */
    // let acc_en = read('acc_en');
    // write('acc_en', acc_en == 0x0f ? 0x00 : 0x0f);

    /* Invoking a function using the AEVMCodec I2C interface */
    // invoke('I2C_WriteRegister', [2, 0x18, 8, 0, [48, 0]], 'i2c');

    /* Log to text file */
    // log(SCRIPT_END_MESSAGE);
	
	
    // USB2ANY case: A general way of sending a packet and geting its reply packet
    // In particular, use sendCommandPacket(cmd,buffer) to send a command packet from
    // host to controller, and use readResponse(...) to get the reply packet from the
    // controller for the packet you sent.
    // i.e. readResponse(this.sendCommandPacket(...));

    // In scripting, use invoke(...) to call a particular method, e.g. sendCommandPacket

    // An example - to just send packet and don't care its reply packet.
    // Note that [101, [0, 72, 1, 0, 2, 0] ] is an 'argument' to (cmd, buffer)
    // i.e cmd is 101 (Cmd_I2C_ReadInternal), buffer is [0, 72, 1, 0, 2, 0]
    // See USB2ANY.prototype.sendCommandPacket = function(cmd, buffer) for more details.
    // invoke('sendCommandPacket', [101, [0, 72, 1, 0, 2, 0] ])

    // An example - send packet and get the reply packet
    // In main.js, you define a new function my_sendCommandPacket
    // gc.databind.USB2ANY.prototype.my_sendCommandPacket = function(cmd, buffer) {
    //    return this.readResponse(this.sendCommandPacket(cmd, buffer)).then(...); }
    // see main.js for details
    // you call that function by invoke as show below. 
    invoke('my_sendCommandPacket', [101,[0, 72, 1, 0, 2, 0]]);
    

}